diff -uwr sourceold/scripts/dp88_misc.h source/scripts/dp88_misc.h
--- sourceold/scripts/dp88_misc.h	2011-12-01 11:52:12.871093700 +0800
+++ source/scripts/dp88_misc.h	2012-05-23 10:33:45.755859300 +0800
@@ -9,10 +9,12 @@
 	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
+
 #pragma once
 
 #include "scripts.h"
 #include "engine.h"
+#include "LoopedAnimationController.h"
 
 
 
@@ -104,16 +106,108 @@
 
 
 
-/*------------------------
-Damage animation script
---------------------------*/
+/*!
+* \brief Damage animation script
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This is a generic damage animation script that allows you to choose the health thresholds at which
+* different damage states are applied, rather than being tied into the 25%, 50%, 75% etc permitted
+* by the damage bones mechanism.
+*
+* You can create up to six damage states using this script, with both powered and unpowered versions
+* of each state, however if you don't require all six states you can leave the extras unconfigured.
+*
+* The first state is considered to be the 'healthy' state and is used when the object is above the
+* first damage boundary. Each subsequent state is activated when the health of the object drops
+* below the specified boundary, which is a percentage of total health. So, for instance, if you set
+* boundary 1 to 70 and boundary 2 to 30 your object will animate as follows;
+*
+* Health 71% - 100%: Healthy animation
+* Health 31% - 70%: Damage animation 1
+* Health 1% - 0%: Damage animation 2
+*
+* \param animationName
+*   Name of the animation containing all the damage state frames
+* \param loopAnimation
+*   True if the damage animation should be played in a loop, false otherwise
+* \param healthy_startFrame
+*   First frame number for the healthy state animation
+* \param healthy_endFrame
+*   Last frame number for the healthy state animation
+* \param healthy_startFrame_lowPower
+*   First frame number for the healthy state animation when power is offline, or -1 to use the same
+*   value as healthy_startFrame
+* \param healthy_endFrame_lowPower
+*   Last frame number for the healthy state animation when power is offline, or -1 to use the same
+*   value as healthy_endFrame
+* \param damageBoundary1
+*   Damage percent boundary for the first damage state
+* \param damageBoundary1_startFrame
+*   First frame number for the first damage state animation
+* \param damageBoundary1_endFrame
+*   Last frame number for the first damage state animation
+* \param damageBoundary1_startFrame_lowPower
+*   First frame number for the first damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary1_startFrame
+* \param damageBoundary1_endFrame_lowPower
+*   Last frame number for the first damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary1_endFrame
+* \param damageBoundary2
+*   Damage percent boundary for the second damage state, or -1 to disable this state
+* \param damageBoundary2_startFrame
+*   second frame number for the second damage state animation
+* \param damageBoundary2_endFrame
+*   Last frame number for the second damage state animation
+* \param damageBoundary2_startFrame_lowPower
+*   second frame number for the second damage state animation when power is offline, or -1 to use
+*   the same value as damageBoundary2_startFrame
+* \param damageBoundary2_endFrame_lowPower
+*   Last frame number for the second damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary2_endFrame
+* \param damageBoundary3
+*   Damage percent boundary for the third damage state, or -1 to disable this state
+* \param damageBoundary3_startFrame
+*   third frame number for the third damage state animation
+* \param damageBoundary3_endFrame
+*   Last frame number for the third damage state animation
+* \param damageBoundary3_startFrame_lowPower
+*   third frame number for the third damage state animation when power is offline, or -1 to use
+*   the same value as damageBoundary3_startFrame
+* \param damageBoundary3_endFrame_lowPower
+*   Last frame number for the third damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary3_endFrame
+* \param damageBoundary4
+*   Damage percent boundary for the fourth damage state, or -1 to disable this state
+* \param damageBoundary4_startFrame
+*   fourth frame number for the fourth damage state animation
+* \param damageBoundary4_endFrame
+*   Last frame number for the fourth damage state animation
+* \param damageBoundary4_startFrame_lowPower
+*   fourth frame number for the fourth damage state animation when power is offline, or -1 to use
+*   the same value as damageBoundary4_startFrame
+* \param damageBoundary4_endFrame_lowPower
+*   Last frame number for the fourth damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary4_endFrame
+* \param damageBoundary5
+*   Damage percent boundary for the fifth damage state, or -1 to disable this state
+* \param damageBoundary5_startFrame
+*   fifth frame number for the fifth damage state animation
+* \param damageBoundary5_endFrame
+*   Last frame number for the fifth damage state animation
+* \param damageBoundary5_startFrame_lowPower
+*   fifth frame number for the fifth damage state animation when power is offline, or -1 to use
+*   the same value as damageBoundary5_startFrame
+* \param damageBoundary5_endFrame_lowPower
+*   Last frame number for the fifth damage state animation when power is offline, or -1 to use the
+*   same value as damageBoundary5_endFrame
+*/
 
 class dp88_damageAnimation : public ScriptImpClass
 {
 	void Created ( GameObject* obj );
+  void Detach ( GameObject* obj );
 	void Damaged( GameObject *obj, GameObject *damager, float amount );
 	void Timer_Expired ( GameObject* obj, int number );
-	void Animation_Complete ( GameObject *obj, const char *animation_name );
 
 	void SetDamageAnimation ( GameObject* obj );
 
@@ -125,6 +219,10 @@
 	int damageLevelLowPowerEndFrames[6];
 	bool loopAnimation;
 	bool basePowerState;
+protected:
+  LoopedAnimationController* m_pLoopedAnimCtrl;
+public:
+  dp88_damageAnimation() : m_pLoopedAnimCtrl(0) {}
 };
 
 
diff -uwr sourceold/scripts/dp88_securitySystem.cpp source/scripts/dp88_securitySystem.cpp
--- sourceold/scripts/dp88_securitySystem.cpp	2011-10-11 23:03:38.137695300 +0800
+++ source/scripts/dp88_securitySystem.cpp	2012-04-19 17:33:30.064453100 +0800
@@ -188,8 +188,8 @@
 
 	// Work out position for target box
 	Vector3 pos = Commands->Get_Position( obj );
-	pos.X = pos.X + 2 * cos (facing);
-	pos.Y = pos.Y + 2 * sin (facing);
+	pos.X = pos.X + 2 * cos (DEG_TO_RADF(facing));
+	pos.Y = pos.Y + 2 * sin (DEG_TO_RADF(facing));
 
 	// Move fake target
 	GameObject* fakeTarget = Commands->Find_Object ( fakeTargetId );
diff -uwr sourceold/scripts/dp88_veterancy.cpp source/scripts/dp88_veterancy.cpp
--- sourceold/scripts/dp88_veterancy.cpp	2011-10-23 09:34:51.542968900 +0800
+++ source/scripts/dp88_veterancy.cpp	2012-04-24 21:55:23.658203100 +0800
@@ -14,6 +14,7 @@
 #include "dp88_veterancy.h"
 #include "dp88_custom_timer_defines.h"
 #include "VehicleGameObjDef.h"		// For VEHICLE_TYPE_TURRET
+#include "ScriptableGameObj.h"
 
 /******************************
 Initialise static pointer lists to null
@@ -58,7 +59,7 @@
 
 
 	// If unit is a soldier...
-	if ( Is_Soldier ( obj ) )
+	if ( obj->As_SoldierGameObj() )
 	{
 		infantryVeteranRequirement = Get_Int_Parameter ( "veteran_pointsRequired" );
 		infantryEliteRequirement = Get_Int_Parameter ( "elite_pointsRequired" );
@@ -112,7 +113,7 @@
 
 
 	// Else if unit is a vehicle
-	else if ( Is_Vehicle ( obj ) )
+	else if ( obj->As_VehicleGameObj() )
 	{
 		vehicleVeteranRequirement = Get_Int_Parameter ( "veteran_pointsRequired" );
 		vehicleEliteRequirement = Get_Int_Parameter ( "elite_pointsRequired" );
@@ -168,7 +169,7 @@
 
 	Points given: 50% of ((pointsValue / total hit points) * damage repaired) */
 	else if ( amount < 0 && Get_Object_Type(damager) == Get_Object_Type(obj)
-		&& ( !Is_Vehicle(obj) || Get_Vehicle_Driver ( obj ) != NULL || Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET ) )
+		&& ( !obj->As_VehicleGameObj() || Get_Vehicle_Driver ( obj ) != NULL || Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET ) )
 	{
 		grantVeterancyPoints ( damager, ((pointsValue/totalHitPoints)*(amount*-1)) *0.50f );
 	}
@@ -384,7 +385,7 @@
 	if ( obj == NULL || dead )
 		return;
 
-	if ( Is_Soldier ( obj ) )
+	if ( obj->As_SoldierGameObj() )
 	{
 		// Generate name string for the unit promoted chevron
 		char promotionChevronPreset[27];
@@ -416,7 +417,7 @@
 
 
 
-	else if ( Is_Vehicle ( obj ) )
+	else if ( obj->As_VehicleGameObj() )
 	{
 		// Generate name string for the unit promoted chevron
 		char promotionChevronPreset[27];
@@ -474,7 +475,11 @@
 /* Find veterancy unit object */
 dp88_veterancyUnit* dp88_veterancyUnit::getVeterancyData( GameObject *obj )
 {
-	if ( Is_Soldier ( obj ) && Get_Player_ID ( obj ) != -1 )
+	if (!obj)
+	{
+		return NULL;
+	}
+	if ( obj->As_SoldierGameObj() && Get_Player_ID ( obj ) != -1 )
 		return playerData[Get_Player_ID ( obj )];
 	else
 	{
@@ -508,7 +513,7 @@
 		return;
 
 	// If unit is a soldier and is not driving a vehicle give infantry veterancy points
-	if ( Is_Soldier ( obj ) && Get_Vehicle ( obj ) == NULL )
+	if ( obj->As_SoldierGameObj() && Get_Vehicle ( obj ) == NULL )
 	{
 		infantryVeterancyPoints += points;
 
@@ -523,7 +528,7 @@
 
 
 	// If unit is a vehicle or is driving a vehicle give vehicle veterancy points
-	if ( Is_Vehicle ( obj ) || ( Is_Soldier ( obj ) && Get_Vehicle ( obj ) != NULL ) )
+	if ( obj->As_VehicleGameObj() || ( obj->As_SoldierGameObj() && Get_Vehicle ( obj ) != NULL ) )
 	{
 		vehicleVeterancyPoints += points;
 
@@ -531,7 +536,7 @@
 		if ( vehicleVeterancyPoints >= vehicleEliteRequirement && vehicleEliteRequirement > 0 )
 		{
 			// If unit is a vehicle promote self to elite
-			if ( currentLevel < 2 && Is_Vehicle ( obj ) )
+			if ( currentLevel < 2 && obj->As_VehicleGameObj() )
 				promoteToElite();
 
 			// Otherwise promote the vehicle this unit is driving to elite
@@ -547,7 +552,7 @@
 		else if ( vehicleVeterancyPoints >= vehicleVeteranRequirement && vehicleVeteranRequirement > 0 )
 		{
 			// If unit is a vehicle promote self to veteran
-			if ( currentLevel < 1 && Is_Vehicle ( obj ) )
+			if ( currentLevel < 1 && obj->As_VehicleGameObj() )
 				promoteToVeteran();
 
 			// Otherwise promote the vehicle this unit is driving to veteran
@@ -576,7 +581,7 @@
 	createChevrons ();
 
 	// Send page and promotion sound if unit is a player
-	if ( Is_Soldier ( obj ) && Get_Player_ID ( obj ) >= 0 )
+	if ( obj->As_SoldierGameObj() && Get_Player_ID ( obj ) >= 0 )
 	{
 		// Send page
 		char consoleInput[128];
@@ -592,7 +597,7 @@
 
 
 	// Send page and promotion sound if unit driver is a player
-	else if ( Is_Vehicle ( obj ) && Get_Vehicle_Driver ( obj ) != NULL && Get_Player_ID ( Get_Vehicle_Driver ( obj ) ) >= 0 )
+	else if ( obj->As_VehicleGameObj() && Get_Vehicle_Driver ( obj ) != NULL && Get_Player_ID ( Get_Vehicle_Driver ( obj ) ) >= 0 )
 	{
 		// Send page
 		char consoleInput[128];
@@ -623,7 +628,7 @@
 
 		/* If unit is an infantry unit remove old weapon - immediatly if not
 		currently selected or after a 0.1 second delay otherwise */
-		if ( Is_Soldier ( obj ) )
+		if ( obj->As_SoldierGameObj() )
 		{
 			if ( selectWeapon )
 			{
@@ -670,7 +675,7 @@
 	createChevrons();
 
 	// Send page and promotion sound if unit is a player
-	if ( Is_Soldier ( obj ) && Get_Player_ID ( obj ) >= 0 )
+	if ( obj->As_SoldierGameObj() && Get_Player_ID ( obj ) >= 0 )
 	{
 		// Send page
 		char consoleInput[128];
@@ -686,7 +691,7 @@
 
 
 	// Send page and promotion sound if unit driver is a player
-	else if ( Is_Vehicle ( obj ) && Get_Vehicle_Driver ( obj ) != NULL && Get_Player_ID ( Get_Vehicle_Driver ( obj ) ) >= 0 )
+	else if ( obj->As_VehicleGameObj() && Get_Vehicle_Driver ( obj ) != NULL && Get_Player_ID ( Get_Vehicle_Driver ( obj ) ) >= 0 )
 	{
 		// Send page
 		char consoleInput[128];
@@ -736,7 +741,7 @@
 
 		/* If unit is an infantry unit remove old weapon - immediatly if not
 		currently selected or after a 0.1 second delay otherwise */
-		if ( Is_Soldier ( obj ) )
+		if ( obj->As_SoldierGameObj() )
 		{
 			if ( selectWeapon )
 			{
diff -uwr sourceold/scripts/engine_3dre.h source/scripts/engine_3dre.h
--- sourceold/scripts/engine_3dre.h	2012-01-01 06:32:39.324226700 +0800
+++ source/scripts/engine_3dre.h	2012-04-14 04:09:48.077148400 +0800
@@ -478,11 +478,17 @@
 	virtual void OnShaderDatabaseUnload() {};
 };
 
+#ifndef TTLE_EXPORTS
 class TextureMapperClass : public RefCountClass, ShaderControllerObserver {
+#else
+class TextureMapperClass : public RefCountClass {
+#endif
 protected:
 	unsigned int Stage; // 0008  0020
+#ifndef TTLE_EXPORTS
 	ProgrammableShader *Shader; // 000C  0024
 	const char* ShaderName; // 0010  0028
+#endif
 public:
 	enum {
 		MAPPER_ID_UNKNOWN = 0x0,
@@ -513,12 +519,14 @@
 	TextureMapperClass(TextureMapperClass& src);
 	TextureMapperClass(unsigned int stage=0);
 	TextureMapperClass(INIClass& ini,char* section,unsigned int stage);
+#ifndef TTLE_EXPORTS
 	SHADERS_API void Set_Shader(const char* shader_name, ProgrammableShader* shader = nullptr);
 	ProgrammableShader *Peek_Shader()
 	{
 		return Shader;
 	}
 	ProgrammableShader *Get_Shader();
+#endif
 	virtual void Reset()
 	{
 	}
@@ -537,10 +545,12 @@
 		return false;
 	}
 	~TextureMapperClass();
+#ifndef TTLE_EXPORTS
 	virtual void ApplyToMatrix(Matrix4& mat,int uv_array_index) = 0;
 
 	virtual void OnShaderDatabaseLoad();
 	virtual void OnShaderDatabaseUnload();
+#endif
 }; // 0014  002C
 
 typedef void (*ScriptNotify) (int ID,int notify);
diff -uwr sourceold/scripts/engine_def.cpp source/scripts/engine_def.cpp
--- sourceold/scripts/engine_def.cpp	2011-10-11 23:03:32.718750000 +0800
+++ source/scripts/engine_def.cpp	2012-04-24 11:21:11.197265600 +0800
@@ -18,6 +18,7 @@
 #include "PhysClass.h"
 #include "DefinitionMgrClass.h"
 #include "BaseGameObjDef.h"
+#include "ScriptableGameObjDef.h"
 
 DefinitionClass SCRIPTS_API *Find_Definition(unsigned long id)
 {
@@ -57,22 +58,13 @@
 	return d->Get_ID();
 }
 
-const DefinitionClass SCRIPTS_API *Get_Definition(GameObject *obj)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return 0;
-	}
-	return (DefinitionClass *)&(((ScriptableGameObj *)obj)->Get_Definition());
-}
-
 DefinitionClass SCRIPTS_API *Get_Phys_Definition(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o = (PhysicalGameObj *)As_PhysicalGameObj(obj);
+	PhysicalGameObj *o = obj->As_PhysicalGameObj();
 	if (!o)
 	{
 		return 0;
diff -uwr sourceold/scripts/engine_def.h source/scripts/engine_def.h
--- sourceold/scripts/engine_def.h	2011-10-11 21:54:12.960937500 +0800
+++ source/scripts/engine_def.h	2012-04-24 11:21:11.134765600 +0800
@@ -19,7 +19,6 @@
 DefinitionClass SCRIPTS_API *Find_Named_Definition(const char *name); //Find a DefinitionClass given its name
 DefinitionClass SCRIPTS_API *Find_Definition(unsigned long id); //Find a DefinitionClass given its ID
 unsigned long SCRIPTS_API Get_Definition_Class_ID(const char *name); //get the class ID of a definition (matches the #defines above)
-const DefinitionClass SCRIPTS_API *Get_Definition(GameObject *obj); //Get a DefinitionClass given an object
 DefinitionClass SCRIPTS_API *Get_Phys_Definition(GameObject *obj); //Get a DefinitionClass for the physics class given a PhysicalGameObj
 bool SCRIPTS_API Is_Valid_Preset_ID(unsigned long ID); //Is this a valid preset id
 bool SCRIPTS_API Is_Valid_Preset(const char *Preset); //Is this a valid preset name
diff -uwr sourceold/scripts/engine_dmg.cpp source/scripts/engine_dmg.cpp
--- sourceold/scripts/engine_dmg.cpp	2011-10-11 23:03:31.418945300 +0800
+++ source/scripts/engine_dmg.cpp	2012-04-24 21:56:27.633789000 +0800
@@ -22,6 +22,14 @@
 #include "VehicleGameObjDef.h"
 #ifndef TT_EXPORTS
 RENEGADE_FUNCTION
+int ArmorWarheadManager::Get_Num_Armor_Types()
+AT3(0x00687730, 0x00686FD0, 0x00519180);
+
+RENEGADE_FUNCTION
+int ArmorWarheadManager::Get_Num_Warhead_Types()
+AT3(0x00687740, 0x00686FE0, 0x00519190);
+
+RENEGADE_FUNCTION
 const char *ArmorWarheadManager::Get_Armor_Name(ArmorType)
 AT3(0x006877D0, 0x00687070, 0x00519240);
 
@@ -36,6 +44,51 @@
 RENEGADE_FUNCTION
 const char *ArmorWarheadManager::Get_Warhead_Name(WarheadType)
 AT3(0x006877E0, 0x00687080, 0x005192A0);
+
+RENEGADE_FUNCTION
+float ArmorWarheadManager::Get_Damage_Multiplier(ArmorType, WarheadType)
+AT3(0x006877F0, 0x00687090, 0x00519300);
+
+RENEGADE_FUNCTION
+ArmorWarheadManager::SpecialDamageType	ArmorWarheadManager::Get_Special_Damage_Type( WarheadType type )
+AT3(0x00687E60, 0x00687700, 0x005194E0);
+
+RENEGADE_FUNCTION
+float	ArmorWarheadManager::Get_Shield_Absorbsion( ArmorType armor, WarheadType warhead )
+AT3(0x00687AE0,0x00687380,0x005193A0);
+
+RENEGADE_FUNCTION
+bool				ArmorWarheadManager::Is_Armor_Soft( ArmorType armor )
+AT3(0x00687DD0,0x00687670,0x00519440);
+
+RENEGADE_FUNCTION
+float	ArmorWarheadManager::Get_Special_Damage_Probability( WarheadType type )
+AT3(0x00687E70,0x00687710,0x00519540);
+
+RENEGADE_FUNCTION
+WarheadType ArmorWarheadManager::Get_Special_Damage_Warhead( SpecialDamageType type )
+AT3(0x00687E80,0x00687720,0x005195A0);
+
+RENEGADE_FUNCTION
+float	ArmorWarheadManager::Get_Special_Damage_Duration( SpecialDamageType type )
+AT3(0x00687E90,0x00687730,0x005195F0);
+
+RENEGADE_FUNCTION
+float	ArmorWarheadManager::Get_Special_Damage_Scale( SpecialDamageType type )
+AT3(0x00687EA0,0x00687740,0x00519640);
+
+RENEGADE_FUNCTION
+const char *	ArmorWarheadManager::Get_Special_Damage_Explosion( SpecialDamageType type )
+AT3(0x00687EB0,0x00687750,0x00519690);
+
+RENEGADE_FUNCTION
+float	ArmorWarheadManager::Get_Visceroid_Probability( WarheadType type )
+AT3(0x00687EC0,0x00687760,0x005196E0);
+
+RENEGADE_FUNCTION
+bool	ArmorWarheadManager::Is_Skin_Impervious( SpecialDamageType type, ArmorType skin )
+AT3(0x00687ED0,0x00687770,0x00519740);
+
 #endif
 #ifndef TTLE_EXPORTS
 #include "Engine_Game.h"
@@ -44,7 +97,7 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -61,7 +114,7 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) && (Commands->Get_ID(o) != ConstructionYardID))
@@ -79,13 +132,13 @@
 
 void SCRIPTS_API Repair_All_Static_Vehicles_By_Team(int Team,int type)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_VehicleGameObj(x->Data());
+		VehicleGameObj *o = x->Data();
 		if (o)
 		{
-			if (Get_Object_Type(o) == Team && Is_DecorationPhys(o))
+			if (Get_Object_Type(o) == Team && o->Peek_Physical_Object() && o->Peek_Physical_Object()->As_DecorationPhysClass())
 			{
 				Commands->Send_Custom_Event(o,o,type,0,0);
 			}
@@ -96,7 +149,11 @@
 
 void SCRIPTS_API Set_Max_Health(GameObject *obj,float health)
 {
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	if (!obj)
+	{
+		return;
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -107,7 +164,11 @@
 
 void SCRIPTS_API Set_Max_Shield_Strength(GameObject *obj,float shieldstrength)
 {
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	if (!obj)
+	{
+		return;
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -118,7 +179,11 @@
 
 const char SCRIPTS_API *Get_Shield_Type(GameObject *obj)
 {
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	if (!obj)
+	{
+		return "";
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return "";
@@ -128,7 +193,11 @@
 
 const char SCRIPTS_API *Get_Skin(GameObject *obj)
 {
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	if (!obj)
+	{
+		return "";
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return "";
@@ -138,7 +207,11 @@
 
 void SCRIPTS_API Set_Skin(GameObject *obj,const char *Skintype)
 {
-	DamageableGameObj *o = (DamageableGameObj *)As_DamageableGameObj(obj);
+	if (!obj)
+	{
+		return;
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -150,15 +223,15 @@
 
 void SCRIPTS_API Damage_All_Vehicles_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager)
 {
-	if (!Commands->Get_ID(Host) || !Host)
+	if (!Host)
 	{
 		return;
 	}
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
 		GameObject *obj = x->Data();
-		if (obj && As_VehicleGameObj(obj)) 
+		if (obj) 
 		{
 			Vector3 ObjPosition = Commands->Get_Position(obj);
 			Vector3 TestPosition = Position;
@@ -175,23 +248,28 @@
 
 void SCRIPTS_API Damage_All_Objects_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager) 
 {
-	if (!Commands->Get_ID(Host) || !Host)
+	if (!Host)
 	{
 		return;
 	}
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x) 
 	{
-		GameObject *obj = (GameObject *)x->Data();
-		if (obj && As_ScriptableGameObj(obj)) 
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			Vector3 ObjPosition = Commands->Get_Position(obj);
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
+		{
+			Vector3 ObjPosition = Commands->Get_Position(o2);
 			Vector3 TestPosition = Position;
 			ObjPosition.Z = 0;
 			TestPosition.Z = 0;
-			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance) && (Commands->Get_ID(obj) != Commands->Get_ID(Host)))
+			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance) && (Commands->Get_ID(o2) != Commands->Get_ID(Host)))
 			{
-				Commands->Apply_Damage(obj,Damage,Warhead,Damager);
+				Commands->Apply_Damage(o2,Damage,Warhead,Damager);
 			}
 		}
 		x = x->Next();
@@ -205,7 +283,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				float health = Commands->Get_Health(o);
@@ -236,7 +314,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				float health = Commands->Get_Health(o);
@@ -266,7 +344,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				float health = Commands->Get_Health(o);
@@ -297,7 +375,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -329,7 +407,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -360,7 +438,7 @@
 		SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 		while (x)
 		{
-			GameObject *o = As_BuildingGameObj(x->Data());
+			GameObject *o = x->Data();
 			if (o)
 			{
 				if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -393,12 +471,9 @@
 		GameObject *obj = z->Data();
 		if (obj)
 		{
-			if (As_SoldierGameObj(obj) || As_VehicleGameObj(obj))
-			{
 				float Health = Commands->Get_Max_Health(obj) + Commands->Get_Max_Shield_Strength(obj);
 				Commands->Apply_Damage(obj,(Health / 2),"None",0);
 			}
-		}
 		z = z->Next();
 	}
 }
@@ -407,22 +482,18 @@
 {
 	if (DamageRadius > 0)
 	{
-		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+		SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 		while (x)
 		{
 			GameObject *o = x->Data();
 			if (o)
 			{
-				if (As_VehicleGameObj(o))
-				{
 					float health = Commands->Get_Health(o);
 					if (health > 0)
 					{
 						Vector3 pos1 = Commands->Get_Position(o);
 						Vector3 pos2 = Location;
-
 						float Distance = Commands->Get_Distance(pos1,pos2);
-
 						if (Distance <= DamageRadius)
 						{
 							float Max_Health = Commands->Get_Max_Health(o);
@@ -432,7 +503,6 @@
 						}
 					}
 				}
-			}
 			x = x->Next();
 		}
 	}
@@ -440,11 +510,11 @@
 
 void SCRIPTS_API Set_Damage_Points(GameObject *obj,float points)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	DamageableGameObj *o = (DamageableGameObj*)As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -454,11 +524,11 @@
 
 void SCRIPTS_API Set_Death_Points(GameObject *obj,float points)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	DamageableGameObj *o = (DamageableGameObj*)As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return;
@@ -472,7 +542,7 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if ((Get_Object_Type(o) == Team) && (Commands->Get_ID(o) != ConstructionYardID))
@@ -496,10 +566,10 @@
 
 void SCRIPTS_API Repair_All_Turrets_By_Team(int team,float health)
 {
-	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_VehicleGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if (Get_Object_Type(o) == team && (Get_Vehicle_Mode(o) == VEHICLE_TYPE_TURRET))
@@ -522,19 +592,24 @@
 
 void SCRIPTS_API Damage_All_Objects_In_Zone(GameObject *Zone,float Damage,const char *Warhead,GameObject *Damager)
 {
-	if (!Commands->Get_ID(Zone) || !Zone)
+	if (!Zone)
 	{
 		return;
 	}
 	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = x->Data();
-		if (o && As_ScriptableGameObj(o))
+		BaseGameObj *o = x->Data();
+		ScriptableGameObj *o2 = 0;
+		if (o)
 		{
-			if (IsInsideZone(Zone,o))
+			o2 = o->As_ScriptableGameObj();
+		}
+		if (o2)
 			{
-				Commands->Apply_Damage(o,Damage,Warhead,Damager);
+			if (IsInsideZone(Zone,o2))
+			{
+				Commands->Apply_Damage(o2,Damage,Warhead,Damager);
 			}
 		}
 		x = x->Next();
@@ -543,11 +618,11 @@
 
 float SCRIPTS_API Get_Damage_Points(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	DamageableGameObj *o = (DamageableGameObj*)As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return 0;
@@ -557,11 +632,11 @@
 
 float SCRIPTS_API Get_Death_Points(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	DamageableGameObj *o = (DamageableGameObj*)As_DamageableGameObj(obj);
+	DamageableGameObj *o = obj->As_DamageableGameObj();
 	if (!o)
 	{
 		return 0;
@@ -571,34 +646,34 @@
 
 void SCRIPTS_API Damage_Occupants(GameObject *obj,float Damage,const char *Warhead)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	int x = o->Get_Definition().Get_Seat_Count();
 	for (int i = 0;i < x;i++)
 	{
 		if (o->Get_Occupant(i))
 		{
-			Commands->Apply_Damage((GameObject *)o->Get_Occupant(i),Damage,Warhead,0);
+			Commands->Apply_Damage(o->Get_Occupant(i),Damage,Warhead,0);
 		}
 	}
 }
 
 void SCRIPTS_API Kill_Occupants(GameObject *obj)
 {
-	if (!Commands->Get_ID(obj) || !obj || !As_VehicleGameObj(obj))
+	if (!obj || !obj->As_VehicleGameObj())
 	{
 		return;
 	}
-	VehicleGameObj *o = (VehicleGameObj *)obj;
+	VehicleGameObj *o = obj->As_VehicleGameObj();
 	int x = o->Get_Definition().Get_Seat_Count();
 	for (int i = 0;i < x;i++)
 	{
 		if (o->Get_Occupant(i))
 		{
-			Commands->Apply_Damage((GameObject *)o->Get_Occupant(i),100,"Death",0);
+			Commands->Apply_Damage((GameObject *)o->Get_Occupant(i),99999,"Death",0);
 		}
 	}
 }
@@ -609,14 +684,12 @@
 	//does to all other vehicles. It can also force friendly fire
 	if (DamageRadius > 0)
 	{
-		SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
+		SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 		while (x)
 		{
 			GameObject *o = x->Data();
 			if (o)
 			{
-				if (As_VehicleGameObj(o))
-				{
 					float health = Commands->Get_Health(o);
 					if (health > 0)
 					{
@@ -649,7 +722,6 @@
 							}
 						}
 					}
-				}
 			}
 			x = x->Next();
 		}
